/************************************************
*   carddemo.c
*
*   Author:      Jorma Jormakka
*   Description: 
*   Date:        9.7.1991
*************************************************/ 
#include "x.ext"
#include "win.ext"

extern XColor *xcolor;
extern int gplanes;
extern void put_pack();
void inittrace();
void savetrace();
extern char *int_to_string();
extern long string_to_int();
extern short homex,homey;
static short max;
static int order[DECK_SIZE];
extern int spider_xoff;
static int spider11=0;

int debug=0;
int fill_solitairemenu(max,pmax,window,linelength,id,x,y,xsize,ysize,
		col1,col2,col3,col4,col5)
int max,pmax,window,linelength;
int id,x,y,xsize,ysize,col1,col2,col3,col4,col5;
{
 LINE10 *u1;
 char **u2;
 int *chosen;
 
 if(id<0) return 1;
 
 if(create_menustructure(&u1,&u2,&chosen,max,pmax,linelength)) {
  xkoord=10;ykoord=10;
  textXYf(xkoord,&ykoord,"failed to allocate menu",15,0);	
  return -1;
 }
 strcpy(u2[0],"Exit ");
 strcpy(u2[1],"Klondyke solitaire ");
 strcpy(u2[2],"Spider solitaire 4 colors ");
 strcpy(u2[3],"Spider solitaire black-red");
 strcpy(u2[4],"New game? "); 

 u1[0].xcord=cs*strlen("New game? ");
 u1[0].ycord=4*cr; 
 u1[0].parmax=1;
 u1[0].size=u1[0].bsize=5;
 strcpy(u1[0].name,"No");

 make_popup_menu(id,x,y,xsize,ysize,col1,col2,col3,col4,col5,u1,u2,chosen,
 		max,pmax,window,linelength);
 return 0;
}

/*******************************************************************
 * move_ok checks if putting a card is allowed according to the rules
 * of klondike or spider solitaire
 * move_ok returns 1 if move is OK, 
 *                 0 if not OK  
 *                -1 if a whole suite (13 cards) is removed (in spider)
 * if move_ok returns 1 or 0 the card is still hidden and removed 
 * from the stack
 * if move_ok returns -1, the cards are freed
 * move_ok can return -1 only if id is an ace, so not on pack move 
 *******************************************************************/
int move_ok(id,xnew,ynew,spider,king) 
int id;short *xnew,*ynew;int spider;int *king;
{
 int id2,xsave,ysave,lim,id3,res=0;
 
 xsave=wd_object[id-1].xcord;ysave=wd_object[id-1].ycord;

 id2=get_one_under(id);
 /* id2 is on top in stack and under id */
 if(id2) { /* under is some card, can the card be put here */
  if(wd_object[id2-1].i4) return 0;/* id2 is turned card back up */  
  res=over_another_card(id,id2,xnew,ynew,spider,king);
  /* over another card returns 1 is move OK, 0 if move not OK    */
  /* and -1 if suite removed. Savetrace traces move if res=1     */
  /* savetrace writes bound for a full suite in check_if_full... */
  if(res>0) savetrace(id,res,*xnew,*ynew,0,0);
  return res;
 }
 else {
   /* if there is a card under id, but it is not on top, move not OK */ 
  id2=any_card(wd_object[id-1].xcord+XSIZE/2,wd_object[id-1].ycord+YSIZE/2);
  if(id2) return 0;
  
  /* no card under this card */
  if(spider) lim=XOFF+10*XPOS;else lim=XOFF+7*XPOS;

  if(!spider && wd_object[id-1].ycord<YPOS) {
    /* if not spider and trying to move it to the upper places */
   if(wd_object[id-1].xcord>3*XPOS-XDIF && wd_object[id-1].xcord<lim+3){
    /* the move is OK if the card is ace and nothing is under, else not OK */
    if(id==2 || id==15 || id==28 || id==41) { /* if ace */
     *ynew=10;	
     *xnew=XOFF+XPOS*((wd_object[id-1].xcord+XDIF)/XPOS);
     res=1;    
     wd_object[id-1].xcord= *xnew;wd_object[id-1].ycord= *ynew;
     id2=get_one_under(id);if(id2) res=0; 
     /* here res can only be 1 or 0 */
     if(res) savetrace(id,res,*xnew,*ynew,0,0);
    }    
   }
  }
  else {
    /* putting cards on empty places on the table */
   if(wd_object[id-1].xcord>0 && wd_object[id-1].xcord<lim+3) {
    if (0 /*id!=14 && id!=27 && id!=40 && id!=53 */) {
      /* let it be a rule that if table is empty, anything can be put to it */
      /* not only the four kings */
     res=0;
    }
    else {
     *ynew=YPOS;	
     *xnew=XOFF+XPOS*((wd_object[id-1].xcord+XDIF)/XPOS);  	
     res=1;
     wd_object[id-1].xcord= *xnew;wd_object[id-1].ycord= *ynew;
     id2=get_one_under(id);if(id2) res=0;     
     /* here res can only be 1 or 0 */
     if(res) savetrace(id,res,*xnew,*ynew,0,0);
    }	
   }
  }
 }
 wd_object[id-1].xcord=xsave;wd_object[id-1].ycord=ysave;
 return(res);
}

int over_another_card(id,id2,xnew,ynew,spider,king) 
int id,id2;short *xnew,*ynew;int spider;int *king;
{
 if(spider) return(over_another_card2(id,id2,xnew,ynew,spider,king));
 else return(over_another_card1(id,id2,xnew,ynew));
}

/***********************************
 * ordinary solitaire rules
 ***********************************/
int over_another_card1(id,id2,xnew,ynew) int id,id2;short *xnew,*ynew;
{
 
 if(wd_object[id2-1].ycord<YPOS) {
  /* if id is one bigger than id2 and id2 is not a king */
  if((id-2)%52==(id2-1)%52 && ((id2-2)%13)!=12) {
   *ynew=wd_object[id2-1].ycord+2;	
   *xnew=wd_object[id2-1].xcord;	    
   return 1;
  }
  else return 0;	
 }
 else {
  if     (id2>= 2 && id2<=14) {if(id2== 2 || (id!=id2-1+13 && id!=id2-1+39)) 
   return 0;}
  else if(id2>=15 && id2<=27) {if(id2==15 || (id!=id2-1-13 && id!=id2-1+13)) 
   return 0;}
  else if(id2>=28 && id2<=40) {if(id2==28 || (id!=id2-1-13 && id!=id2-1+13)) 
   return 0;}
  else if(id2>=41 && id2<=53) {if(id2==41 || (id!=id2-1-13 && id!=id2-1-39)) 
   return 0;}

  *ynew=wd_object[id2-1].ycord+YDIF;	
  *xnew=wd_object[id2-1].xcord;

  return 1;      	
 }
} 

/***********************************
 * spider solitaire rules
 ***********************************/
int over_another_card2(id,id2,xnew,ynew,spider,king) 
     int id,id2;short *xnew,*ynew;int spider;int *king;
{
 /* when can a card id be put on top of card id2? */

 /* first rule: regardless of suit, a card num-1 can be on top of num */ 
 if((id2-2)%13!=(id-2)%13+1) return 0;
 *ynew=wd_object[id2-1].ycord+YDIF;	
 *xnew=wd_object[id2-1].xcord;	 

 /* second rule, if id is an ace, check if all from 1-13 are in the pile */
 return(check_if_full_suite(id,id2,*xnew,*ynew,0,spider,king));
} 


int allowed_pack(max,order4,spider) int max;int *order4;int spider; 
{
 int j;

 if(!spider) return 1;

 for(j=0;j<=max;j++){ 
 
  if(spider==1) {

   /* order4[j] and order4[j+1] are following numbers */ 
   if(j+1<=max && ((order4[j]-2)%13+1!=(order4[j+1]-2)%13 )) {

     /* check that they are same suite */
    if((order4[j]-2)/13 == (order4[j+1]-2)/13 ) {
     return 0;
    }
   }

   /* if order4[j] is king, order4[j+1] must be an ace of different suite */
   if(j+1<=max && (order4[j]-2)%13==12) return 0;
  }
  else if(spider==2){
   /* order4[j] and order4[j+1] are following numbers */ 
   if(j+1<=max && ((order4[j]-2)%13+1!=(order4[j+1]-2)%13 )) {

     /* check that they are different colors */
    if(((order4[j]-2)/13)%2 == ((order4[j+1]-2)/13)%2 ) {
     return 0;
    }
   }
  
   /* if order4[j] is king, order4[j+1] must be an ace of different color */
   if(j+1<=max && (order4[j]-2)%13==12) {
    return 0;
   }
  }
 }
 return 1;
}

/**********************/
int edi101_ope()
{
  /* wd_object[119] must be free */
 flush_mouse();
 if(wd_object[119].type!=FREE_OBJ) return 1;

 fill_solitairemenu(1,5,5,50,120,7*cs,400,40*cs,3*cs+5*cr,Co1,Co2,Co3,Co4,Co5); 
 put_wd_objects(120,120);
 buttons=0;

 return 0;	
}


int solitaire()
{
 register int k;

 int i,j,ret;
 int xt,yt,xk,yk;
 unsigned char deck[DECK_SIZE];
 int x,y,xsize,ysize; 

 inittrace(1); /* use old trace */ 
 clearwin(0,0,X__max,Y__max,2); 
 y=Y__max-120;
 x=X__max-40;
 getpicture("queue.fn2",x,y,&xsize,&ysize);
 y=Y__max-80;
 x=X__max-40;
 getpicture("arrow.fn2",x,y,&xsize,&ysize);
 y=Y__max-40;
 x=X__max-40;
 getpicture("start.fn2",x,y,&xsize,&ysize);

 if(spider11==0) {
  shuffle_deck(deck,52);

  /* put the deck on the table */
  rectangle(XPOS*3+XOFF,10,XPOS*3+XOFF+XSIZE,10+YSIZE,0);
  rectangle(XPOS*4+XOFF,10,XPOS*4+XOFF+XSIZE,10+YSIZE,0); 
  rectangle(XPOS*5+XOFF,10,XPOS*5+XOFF+XSIZE,10+YSIZE,0);
  rectangle(XPOS*6+XOFF,10,XPOS*6+XOFF+XSIZE,10+YSIZE,0);  
 
  rectangle(XPOS*0+XOFF,YPOS,XPOS*0+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*1+XOFF,YPOS,XPOS*1+XOFF+XSIZE,YPOS+YSIZE,0); 
  rectangle(XPOS*2+XOFF,YPOS,XPOS*2+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*3+XOFF,YPOS,XPOS*3+XOFF+XSIZE,YPOS+YSIZE,0);   
  rectangle(XPOS*4+XOFF,YPOS,XPOS*4+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*5+XOFF,YPOS,XPOS*5+XOFF+XSIZE,YPOS+YSIZE,0); 
  rectangle(XPOS*6+XOFF,YPOS,XPOS*6+XOFF+XSIZE,YPOS+YSIZE,0);

  gplanes=4;
  load_card_back(1,tplane1); 
 
  gplanes=4;load_one_card((int)deck[0],XPOS*0+XOFF,YPOS,0);
  gplanes=4;load_one_card((int)deck[1],XPOS*1+XOFF,YPOS,1);
  gplanes=4;load_one_card((int)deck[2],XPOS*1+XOFF,YPOS+YDIF,0); 
  for(i=3;i<=4;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*2+XOFF,YPOS+YDIF*(i-3),1);
  }
  gplanes=4;load_one_card((int)deck[5],XPOS*2+XOFF,YPOS+YDIF*2,0);    
  for(i=6;i<=8;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*3+XOFF,YPOS+YDIF*(i-6),1);
  }
  gplanes=4;load_one_card((int)deck[9],XPOS*3+XOFF,YPOS+YDIF*3,0); 
  for(i=10;i<=13;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*4+XOFF,YPOS+YDIF*(i-10),1);
  }
  gplanes=4;load_one_card((int)deck[14],XPOS*4+XOFF,YPOS+YDIF*4,0);   
  for(i=15;i<=19;i++){
   gplanes=4;load_one_card((int)deck[i],XPOS*5+XOFF,YPOS+YDIF*(i-15),1);
  }
  gplanes=4;load_one_card((int)deck[20],XPOS*5+XOFF,YPOS+YDIF*5,0);
  for(i=21;i<=26;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*6+XOFF,YPOS+YDIF*(i-21),1);
  }
  gplanes=4;load_one_card((int)deck[27],XPOS*6+XOFF,YPOS+YDIF*6,0);
 
  draw_buf2(40,10,0,0,XSIZE,YSIZE,40&7,XSIZE/8+1,ISIZE,tplane1);
 
  savetrace(0,-2,0,0,0,0); /* put a bound */
  ret=do_solitaire_engine(1,deck,spider11);
  if(ret==1) return 1;
 }
 else if(spider11){ /* spider solitaire */
  spider_xoff=0;
  shuffle_deck(deck,104);
  gplanes=4;
  load_card_back(1,tplane1); 
  rectangle(XPOS*0+XOFF,YPOS,XPOS*0+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*1+XOFF,YPOS,XPOS*1+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*2+XOFF,YPOS,XPOS*2+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*3+XOFF,YPOS,XPOS*3+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*4+XOFF,YPOS,XPOS*4+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*5+XOFF,YPOS,XPOS*5+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*6+XOFF,YPOS,XPOS*6+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*7+XOFF,YPOS,XPOS*7+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*8+XOFF,YPOS,XPOS*8+XOFF+XSIZE,YPOS+YSIZE,0);
  rectangle(XPOS*9+XOFF,YPOS,XPOS*9+XOFF+XSIZE,YPOS+YSIZE,0);

  /* 0...5 */
  for(i=0;i<5;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*0+XOFF,YPOS+YDIF*(i-0),1);
  }
  gplanes=4;load_one_card((int)deck[5],XPOS*0+XOFF,YPOS+YDIF*5,0);

  /* 6...11 */
  for(i=6;i<11;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*1+XOFF,YPOS+YDIF*(i-6),1);
  }
  gplanes=4;load_one_card((int)deck[11],XPOS*1+XOFF,YPOS+YDIF*5,0);

  /* 12..17 */
  for(i=12;i<17;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*2+XOFF,YPOS+YDIF*(i-12),1);
  }
  gplanes=4;load_one_card((int)deck[17],XPOS*2+XOFF,YPOS+YDIF*5,0);
  
  /* 18..23 */
  for(i=18;i<23;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*3+XOFF,YPOS+YDIF*(i-18),1);
  }
  gplanes=4;load_one_card((int)deck[23],XPOS*3+XOFF,YPOS+YDIF*5,0);

  /* 24..28 */
  for(i=24;i<28;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*4+XOFF,YPOS+YDIF*(i-24),1);
  }
  gplanes=4;load_one_card((int)deck[28],XPOS*4+XOFF,YPOS+YDIF*4,0);
  /* 29..33 */
  for(i=29;i<33;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*5+XOFF,YPOS+YDIF*(i-29),1);
  }
  gplanes=4;load_one_card((int)deck[33],XPOS*5+XOFF,YPOS+YDIF*4,0);
  /* 34..38 */
  for(i=34;i<38;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*6+XOFF,YPOS+YDIF*(i-34),1);
  }
  gplanes=4;load_one_card((int)deck[38],XPOS*6+XOFF,YPOS+YDIF*4,0);
  /* 39..43 */
  for(i=39;i<43;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*7+XOFF,YPOS+YDIF*(i-39),1);
  }
  gplanes=4;load_one_card((int)deck[43],XPOS*7+XOFF,YPOS+YDIF*4,0);
  /* 44..48 */
  for(i=44;i<48;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*8+XOFF,YPOS+YDIF*(i-44),1);
  }
  gplanes=4;load_one_card((int)deck[48],XPOS*8+XOFF,YPOS+YDIF*4,0);
  /* 49..53 */
  for(i=49;i<53;i++) {
   gplanes=4;load_one_card((int)deck[i],XPOS*9+XOFF,YPOS+YDIF*(i-49),1);
  }
  gplanes=4;load_one_card((int)deck[53],XPOS*9+XOFF,YPOS+YDIF*4,0);

  draw_buf2(40,10,0,0,XSIZE,YSIZE,40&7,XSIZE/8+1,ISIZE,tplane1);
 
  savetrace(0,-2,0,0,0,0); /* put a bound */
  ret=do_solitaire_engine(1,deck,spider11);
  if(ret==1) return 1;
 }
 return 0 ;
}

/***************************
 * bridge is not implemented
 * only started long a go
 ***************************/
int bridge()
{
 register int k;

 int i,j,moving=0;
 int xt,yt,xk,yk;
 unsigned char deck[104];
 
 shuffle_deck(deck,104);	
 clearwin(0,0,X__max,Y__max,2); 

 /* put the deck on the table */
 for(i=1;i<=104;i++) {
  pop_card2((int)deck[i-1]); 	
  wd_object[(int)deck[i-1]-1].options=0;  
  wd_object[(int)deck[i-1]-1].xcord=20; 
  wd_object[(int)deck[i-1]-1].ycord=20; 	
  movingPicture(wd_object[(int)deck[i-1]-1].xcord,
                wd_object[(int)deck[i-1]-1].ycord,
              0,(int)deck[i-1]);
  push_card((int)deck[i-1]);  	
 }
 /* deal into four hands */
 for(i=1;i<=13;i++) {
  for(j=1;j<=4;j++) {
   X=25; Y=25;
   moving=pop_up_wanted(X,Y);         
   if(moving) {
    pop_card(moving);
    for(k=0;k<20;k++) {
     X=wd_object[moving-1].xcord+12;     	
     Y=wd_object[moving-1].ycord+4*(j-1);     
     movingPicture(X,Y,1,moving);
    }
    for(k=0;k<i%13;k++) {
     X=wd_object[moving-1].xcord+8;     	
     movingPicture(X,Y,1,moving);
    }     
    push_card(moving);
    moving=0;  	      
   }         
  }
 }
 return(0);
}

int push_card(id) int id;
{
 long id1;
 char file_name2[30];
 
 cardname(file_name2,id-1);
 pushf_to_shadow(id,file_name2);
 wd_object[id-1].options ^= WINDOW_HIDDEN;
 return(update_over(id));     
}
int pop_card(id) int id;
{
 long id1;
 char file_name2[30];
 
 cardname(file_name2,id-1);
 return(popf_up_shadow(id,file_name2));
} 
int pop_card2(id) int id;
{
 long id1;
 char file_name2[30];
 
 cardname(file_name2,id-1);
 return(popf_up_shadow2(id,file_name2));
} 


int do_solitaire_engine(maxi,deck,spider) 
int maxi;unsigned char *deck;int spider;
{
 int i,j,command,current,deckmax,lasti,found,id2;
 char line[10];int x1,y1,len,empty,order2[2];
 int order3[10];int k;
 
 if(spider) {
  current=54;deckmax=103;
 }
 else {
  current=28;deckmax=51;
 }
 if(init_engine(maxi)) return(1);

 while(1) {	
  do {
   command=do_solit_operations(spider);
   if(command== -1) {
    /* buttons pressed, user action testing {buttons,X,Y} */ 	
    if(X>=40 && X<40+XSIZE && Y>=10 && Y<10+YSIZE ){
     if(current>deckmax) {
      clearwin(40,10,200,95,2);
      draw_buf2(40,10,0,0,XSIZE,YSIZE,40&7,XSIZE/8+1,ISIZE,tplane1);     	
      if(spider) {
       current=104;deckmax=103;
      }
      else {
       current=52;deckmax=51;
      }
      lasti=i=0;
      while(1) {
       i=pop_up_wanted(130,40);
       if(!i) break;
       if(i<2 || lasti==i) {illegal_pointer(19);getchar();break;}
       lasti=i;

       /* a pack is all dealt in klondyke solitaire                  */       
       /* temporarily remove cards of the pack from the table        */
       /* make them hidden and set free, they do not have background */ 
       /* after this we deal the cards again                         */
       wd_object[i-1].options ^= WINDOW_HIDDEN;
       update_over(i);
       if(!(wd_object[i-1].options&WINDOW_HIDDEN))
	 printf("carddemo: error %d not hidden",i);
       wd_object[i-1].type=FREE_OBJ;   
       if(wd_object[i-1].background) { 
        b_free(wd_object[i-1].background);
        wd_object[i-1].background=0;
       }       
       if(current>0) deck[--current]=i;
      }
     }
     if(!spider) {
      k=0;
      for(i=current;i<current+3;i++) {
       if(i>deckmax) break;
       gplanes=4;
       id2=(int)deck[i];
       load_one_card(id2,100+12*((i-current)%3),10+10*((i-current)%3),0);
       order3[k]=id2;k++;
      }
      current += 3;
      savetrace(0,-3,0,0,order3,2); /* put a bound of type deal */
      if(current>deckmax) {
       fillbox2(40,10,XSIZE,YSIZE,xcolor[2].pixel); 
     /* clearwin(40,10,40+XSIZE,10+YSIZE,2);*/
       rectangle(40,10,40+XSIZE,10+YSIZE,0);
      }       	      	
     }
     else { /* in spider, deal on cards 5 hands, that's all */
      empty=0;
      for(i=current;i<=deckmax && i<current+10;i++){/* check empty places*/
       x1=XPOS*(i-current)+XOFF;
       y1=YPOS+YSIZE-1;
       if(!any_card(x1,y1)) {empty=1;break;}
      }
      if(!empty) {
       k=0;
       for(i=current;i<=deckmax && i<current+10;i++) {
        x1=XPOS*(i-current)+XOFF;
        for(j=40;j>=0;j--) {
      	 y1=YPOS+YDIF*j+YSIZE-1;
         if(any_card(x1,y1)) break;
        }
        y1=YPOS+YDIF*(j+1);
        gplanes=4;
        id2=(int)deck[i];
        load_one_card(id2,x1,y1,0);
        order3[k]=id2;k++;
       }
       savetrace(0,-3,0,0,order3,9); /* put a bound of type deal */
       current +=10;
       if(current>deckmax) {
        fillbox2(40,10,XSIZE,YSIZE,xcolor[2].pixel); 
        rectangle(40,10,40+XSIZE,10+YSIZE,0);
       }
      }
     }     
    }
    else if(X>=X__max-40 && X<X__max && Y>Y__max-120 && Y<Y__max-80) {
     go_move_forward(&current,deck,deckmax,spider);
    }
    else if(X>=X__max-40 && X<X__max && Y>Y__max-80 && Y<Y__max-40) {
     take_move_back(&current,deck,deckmax,spider);
    }
    else if(X>=X__max-40 && X<X__max && Y>Y__max-40 && Y<Y__max) {
     edi101_ope();
    }
   }
   else if (command==1) { /* exit asked */
     return 1;

   }
  } while(!kbhit());
 }
}

int do_solit_operations(spider) int spider;
{
 int i,j,command,max1,res,king;
 short xnew,ynew,xold,yold;
 int x1,y1,len;int order2[3]; 
 int *chosen;
 LINE10 *u1;
 int found;

 buttons=0;
 readmouse(&buttons,&X,&Y);

 if(!buttons) {  /* buttons released */
 
  if(mouse_off) { 
   if(moving) {
    if(wd_object[moving-1].type==CARD_OBJ) {
     /* we come here when releasing the mouse after moving a card */
     /* or a pack of cards */
 
     if(moving==MAX_WINDOWS) { /* this is a pack move */
      
      /* put new coordinates to order[max], other can still have old coords */
      wd_object[order[max]-1].xcord=wd_object[moving-1].xcord;
      wd_object[order[max]-1].ycord=wd_object[moving-1].ycord;

      if(Y<YPOS) res=0;
      else res=move_ok(order[max],&xnew,&ynew,spider,&king);
      /* a pack move cannot return -1 since cards are still in a pack */
      if(!res) {
	/* if move_ok returns 0, move is not OK, take the pack back */
       xold=wd_object[moving-1].xcord;
       yold=wd_object[moving-1].ycord;
       for(j=0;j<=8;j++) {
        xnew= ((8-j)*xold+j*homex)>>3;
        ynew= ((8-j)*yold+j*homey)>>3;      
        wd_object[order[max]-1].xcord=xnew;
        wd_object[order[max]-1].ycord=ynew;
        movingPicture(xnew,ynew,1,moving);
       }
      }
      /* draw the pack on the new place */
      else movingPicture(xnew,ynew,1,moving);
      
      /* after move_ok moving is still hidden and not in stack */
      /* the pack card moving will be freed by put_pack        */
      x1=wd_object[moving-1].xcord;
      y1=wd_object[moving-1].ycord+wd_object[moving-1].ysize-YSIZE;
      
      /* after put_pack all cards of the pack are visible and in stack */
      /* the pack card moving is freed                                 */
      /* the pack card does not have background in a file              */
      put_pack(max,order,MAX_WINDOWS);moving=0;

      /* remove from stack but do not hide packsize-1 cards      */
      /* this we do so that find_stacking_order_by_coord_to_len1 */
      /* has only one card of the former pack to consider        */
      for(len=0;len<=max-1;len++) update_over(order[len]);

      find_stacking_order_by_coord_to_len1(x1,y1,&len,order2,2);

      if(len==1) { /* pack is put on an empty place */

       wd_object[order2[0]-1].options ^= WINDOW_HIDDEN;            
       update_over(order2[0]);
       for(j=max-1;j>=0;j--) {
        i=order[j];
        update_over(i);
       }
      }
      else if (len==2){ /* pack is put on a card */
       /* order2[0] and order2[1] are hidden and not in stack */
       wd_object[order2[1]-1].options ^= WINDOW_HIDDEN;            
       update_over(order2[1]);
       wd_object[order2[0]-1].options ^= WINDOW_HIDDEN;            
       update_over(order2[0]);

       /* restore the rest of the pack, those cards are not hidden */
       /* but they are removed from the stacking order             */
       for(len=max-1;len>=0;len--) {
        update_over(order[len]);
       } 
       if(spider && 
        check_if_full_suite(order2[0],order2[1],0,0,1,spider,&king)==-1) {
        gplanes=4;load_one_card(king,300+spider_xoff*20,10,0);
        spider_xoff++;
       }
       else {
	if(spider) {;}
       }
      }
      else {
       printf("carddemo: error, this should be impossible len=%d\n",len);
       printf("x1=%d y1=%d\n",x1,y1);
      }
     }
     else {
      /* not a pack move */
      res=move_ok(moving,&xnew,&ynew,spider,&king);
      if(!res) {
       xold=wd_object[moving-1].xcord;
       yold=wd_object[moving-1].ycord;       
       for(j=0;j<=8;j++) {
        xnew= ((8-j)*xold+j*homex)>>3;
        ynew= ((8-j)*yold+j*homey)>>3;            	
        movingPicture(xnew,ynew,1,moving);
       }
       /* put the card down */
       wd_object[moving-1].options ^= WINDOW_HIDDEN;
       update_over(moving);
      }
      else if (res==-1) { /* card filled a suite in spider */
       gplanes=4;load_one_card(king,300+spider_xoff*20,10,0);
       spider_xoff++;
       moving=0;
      }
      else {
       movingPicture(xnew,ynew,1,moving);
       /* put the card down */
       wd_object[moving-1].options ^= WINDOW_HIDDEN;
       update_over(moving);
      }       
     }
    }
    /* these are for other than card type */
    else if(wd_object[moving-1].options & OCTET_ALIGNED) {
     xnew=(wd_object[moving-1].xcord>>3)<<3;
     movingPicture(xnew,wd_object[moving-1].ycord,1,moving);	
     wd_object[popwindow-1].options ^= WINDOW_HIDDEN;
     update_over(popwindow);popwindow=0;
    }
    if(moving) if_b_opt_bgtofile(moving);
    popwindow=moving=0;
    setmouselim(0,0,X__max,Y__max);    
   }
   else if(popwindow) {
    if_b_opt_bgtofile(popwindow);
    popwindow=0;
   }
   showmouse();mouse_off=0; 
  }
 }
 else { /* buttons pressed, picking up something */
  if(!mouse_off) { 
   hidemouse();mouse_off=1;
   if(Y<YPOS) {
    popwindow=pop_up_wanted(X,Y);
    if(popwindow) {
     /* pick up the card */
     wd_object[popwindow-1].options ^= WINDOW_HIDDEN;
     update_over(popwindow);
     if(!(wd_object[popwindow-1].options&WINDOW_HIDDEN))
      printf("carddemo:error, card picked up and not hidden\n");
    }
   }   
   else {
    for(j=0;j<DECK_SIZE;j++) order[j]=0;
    popwindow=move_pack(X,Y,order,&max,0,MAX_WINDOWS);
     
    if(popwindow && (!(wd_object[popwindow-1].options&WINDOW_HIDDEN) 
        || !over_is_zero(popwindow-1))) {
     printf("carddemo:error, after move_pack %d not hidden\n",popwindow);
     if(over_is_zero(popwindow-1)) printf("over_is_zero\n");
     else printf("over not zero\n");
    }

    if(popwindow==MAX_WINDOWS) {
     /* if it is a pack move, check if the pack is allowed */
     if(!allowed_pack(max,order,spider)) {
       put_pack(max,order,MAX_WINDOWS);
      popwindow=0;
     }
    }
   }
   if(popwindow) {
     /* take background from a file */

     if(!(wd_object[popwindow-1].options&WINDOW_HIDDEN) 
        || !over_is_zero(popwindow-1)) {
      printf("carddemo:error, take background %d not hidden\n",popwindow);
      if(over_is_zero(popwindow-1)) printf("over_is_zero\n");
      else printf("over not zero\n");
     }

    if(if_b_opt_bgfromfile(popwindow)>0) 
    {illegal_pointer(22);getchar();getch();}
    moving=0;
   }
  }
  if(moving) {
   if(X<cxoff || Y<cyoff) {illegal_pointer(23);getch();}
   movingPicture(X-cxoff,Y-cyoff,1,moving);
  }
  else if(popwindow) {

   i=popwindow-1;command= -2;
 
   /* popup window menu actions */
   if(wd_object[i].type==POPUP_OBJ) {
    command=pop_up_menu(popwindow,NORMAL_OPERATION);
    chosen=(int *)wd_object[popwindow-1].p3;
    u1=(LINE10 *)wd_object[popwindow-1].p1;
    if(command==0 && chosen[0] == 1) { /* exit */
     while(1) {
      found=0;
      for(i=MAX_WINDOWS;i>1;i--) {
       if(wd_object[i-1].type!=FREE_OBJ) {
	found=1;
        if(over_is_zero(i-1)) {
         if_b_opt_bgfromfile(i);
         wd_object[i-1].options ^= WINDOW_HIDDEN;
         update_over(i); /* release from stacking order */  
         free_one_wd_object(i);
	}
       }
      }
      if(!found) break;
     }
     return 1;
    }
    else if(command==0 && chosen[1] == 1) { 
     while(1) 
     {
      found=0;
      for(i=MAX_WINDOWS;i>1;i--) {
       if(wd_object[i-1].type!=FREE_OBJ) {
	found=1;
        if(over_is_zero(i-1)) {
         if_b_opt_bgfromfile(i);
         wd_object[i-1].options ^= WINDOW_HIDDEN;
         update_over(i); 
         free_one_wd_object(i);
	}
       }
      }
      if(!found) break;
     }
     spider11=0;
     solitaire();
    }
    else if(command==0 && chosen[2] == 1) {
     while(1) 
     {
      found=0;
      for(i=MAX_WINDOWS;i>1;i--) {
       if(wd_object[i-1].type!=FREE_OBJ) {
	found=1;
        if(over_is_zero(i-1)) {
         if_b_opt_bgfromfile(i);
         wd_object[i-1].options ^= WINDOW_HIDDEN;
         update_over(i); 
         free_one_wd_object(i);
	}
       }
      }
      if(!found) break;
     }
     spider11=1;
     solitaire();
    }
    else if(command==0 && chosen[3] == 1) {
     while(1) 
     {
      found=0;
      for(i=MAX_WINDOWS;i>1;i--) {
       if(wd_object[i-1].type!=FREE_OBJ) {
	found=1;
        if(over_is_zero(i-1)) {
         if_b_opt_bgfromfile(i);
         wd_object[i-1].options ^= WINDOW_HIDDEN;
         update_over(i); 
         free_one_wd_object(i);
	}
       }
      }
      if(!found) break;
     }
     spider11=2;
     solitaire();
    }
    else if(command==0 && chosen[4] == 1) {
     if(!strcmp(u1[0].name,"Yes") || !strcmp(u1[0].name,"yes"))
      saveseed();
     return 0;
    }
   }

   /* other window types */
   else if(wd_object[i].type==TEXTWIN_OBJ) 
    command=file_window(popwindow,NORMAL_OPERATION);
   else if(wd_object[i].type==CARD_OBJ) {
     if(!(wd_object[i].options&WINDOW_HIDDEN) || !over_is_zero(i)) {
      printf("carddemo:error, to draw_card %d not hidden\n",i+1);
      if(over_is_zero(i)) printf("over_is_zero\n");
      else printf("over not zero\n");}
    command=draw_card(popwindow,NORMAL_OPERATION);
   }
   else if(wd_object[i].type==ANIMATION_OBJ) 
    command=animate(popwindow,NORMAL_OPERATION);    
   else if(wd_object[i].type & ICON)
    command=draw_icon(popwindow,NORMAL_OPERATION);
   else {
    xkoord=10;ykoord=10;
    textXYf(xkoord,&ykoord,"unknown type",15,0);return(2);
   }
 
   if(command== -4) { /* move window */
    /* at this point popwindow is hidden and not in stack */
    moving=popwindow; 
    homex=wd_object[i].xcord;
    homey=wd_object[i].ycord;    
    cxoff=wd_object[i].xsize/2;
    cyoff=wd_object[i].ysize/2;
    setmouse(wd_object[i].xcord+cxoff,wd_object[i].ycord+cyoff);
    setmouselim(cxoff,cyoff,X__max-cxoff,Y__max-cyoff);
    if(fg_to_fgbuf(moving)) return(2);    
   }
   else if(command== -3) {
    if(!(wd_object[i].options & WINDOW_HIDDEN))
     draw_icon(popwindow,DRAW_ONLY_DO_NOT_STAY);
   }
   else if(command== -2) { /* with cards, comes here after flipping a card */
    /* after flip the window must be exposed, coming here hidden */
    if(wd_object[i].options&WINDOW_HIDDEN) {
     wd_object[i].options ^= WINDOW_HIDDEN;
     update_over(popwindow);
    } 
    else {
      printf("carddemo: error, why %d not hidden?\n",i+1); getchar();}
   }
   else if(command== -1) {free_one_wd_object(popwindow);popwindow=0;}
   else if(command==  0) return(1);/* call operations */      
   else if(command==  1) cannot_find_file(wd_object[i].name);
   else if(command==  2) no_memory();
  }
  else return(-1); /* user action */
 }
 return(0);
}


/*********************************
 * card_demo() is just a simple 
 * routine to show cards. it calls
 * do_card_engine
 *********************************/
int do_card_engine(maxi) int maxi;
{
 int command;
 if(init_engine(maxi)) return(1);
  
 while(1) {	
  do {
   command=do_operations();
   if(command== -1) {
    /* buttons pressed, user action testing {buttons,X,Y} */ 	
   }
  } while(!kbhit());
  if('q'==getch()) return(0);
 }
}

int card_demo()
{
 int i,j;
 
 clearwin(0,0,X__max,Y__max,2);
 gplanes=4;
 load_card_back(1,tplane1);
 
 for(i=1;i<=11;i++) { 
  gplanes=4;
  load_one_card(i+1,56*(i-1),0,0);
 }
 for(i=1+13;i<=11+13;i++){
  gplanes=4; 
  load_one_card(i+1,56*(i-14),66,0);  
 }
 for(i=1+26;i<=11+26;i++) {
  gplanes=4; 
  load_one_card(i+1,56*(i-27),132,0);  
 }
 for(i=1+39;i<=11+39;i++) {
  gplanes=4; 
  load_one_card(i+1,56*(i-40),198,0);        
 }
 for(i=12;i<=13;i++){
  gplanes=4; 
  load_one_card(i+1,56*(i-12),264,0);  
 }
 for(i=12+13;i<=13+13;i++) {
  gplanes=4;
  load_one_card(i+1,56*(i-12-13+2),264,0);  
 }
 for(i=12+26;i<=13+26;i++){
  gplanes=4; 
  load_one_card(i+1,56*(i-12-26+4),264,0);  
 }
 for(i=12+39;i<=13+39;i++) {
  gplanes=4;
  load_one_card(i+1,56*(i-12-39+6),264,0);
 }
 
 if(do_card_engine(1)) {getch();return(1);}
 
 return(0);
}





int any_card_even_hidden(x,y) int x,y;
{
  int i;
 for(i=0;i<MAX_WINDOWS;i++) {
  if(wd_object[i].type!=FREE_OBJ)
  {      
   if(x >= wd_object[i].xcord && 
       x< wd_object[i].xcord + wd_object[i].xsize &&
       y >= wd_object[i].ycord && 
      y< wd_object[i].ycord + wd_object[i].ysize){
     return i+1;
   }
  }
 }
 return 0;
}

int show_order(max,order) int max;int *order;
{
  int i;

  for(i=0;i<=max;i++) {
    if(wd_object[order[i]-1].options&WINDOW_HIDDEN)
      printf("For order[%d]=%d, hidden flag\n",i,order[i]);
    else printf("For order[%d]=%d, exposed flag\n",i,order[i]);
    if(over_is_zero(order[i]-1))
      printf("For order[%d]=%d over is zero\n",i,order[i]);
    else printf("For order[%d]=%d over is nonzero\n",i,order[i]);
    printf("x1=%d y1=%d x2=%d y2=%d\n",
     wd_object[order[i]-1].xcord,
     wd_object[order[i]-1].ycord,
     wd_object[order[i]-1].xcord+wd_object[order[i]-1].xsize,
     wd_object[order[i]-1].ycord+wd_object[order[i]-1].ysize);
  }
  return 0;
}

/***********************************************************
 * when check_if_full suite is called, the move is allowed.
 * only it is possible that the whole suite is removed.
 * returns 1 if allowed move, -1 is suite removed.
 * the routine assumes that id is an ace and id2=2, so if
 * you click an ace with the left mouse button, you get here
 * put=1 means that the id is already put down and visible
 * if so, xnew, ynew are not used and can be set to zero
 ***********************************************************/
int check_if_full_suite(id,id2,xnew,ynew,put,spider,king) 
     int id,id2;short xnew,ynew;int put,spider;int *king;
{
 int j,i;int x1,y1,len,last;int order4[12];

 /* if id is not an ace or id2 is not 2, return */
 if((id-2)%13)     return 1;
 if((id2-2)%13!=1) return 1;

 x1=wd_object[id2-1].xcord;
 y1=wd_object[id2-1].ycord;

 /* YSIZE=65 and YDIF=8, so if id is an ace and id2 is card 2   */
 /* there can be 2,3,4,5,6,7,8,9 under (x,y), that is 8 cards   */
 /* there should be 13 cards, a full suite, but not under (x.y) */
 /* as we come here, id is not put down, it is hidden           */
 /* so order4[0] will be 2, if this is a whole suite            */
 find_stacking_order_by_coord_to_len1(x1,y1,&len,order4,8);
 if(len<8) {  
  /* find...to_len1 has a different understanding of len tan put_... */
  put_back_order(order4,len-1);
  return 1;
 }
 if(order4[0]!=id2) {
  printf("check_if_full..: there is some misunderstanding\n");
  getchar();
 }
 /* find_stacking_order_by_coord_to_len1 (what a long name) lifts */
 /* up cards that it gets to the order vector, so they are hidden */
 /* check if these cards are in order and of the same suit        */
 if(spider==1)      last=(id-2)%52;
 else if(spider==2) last=(id-2)%26;
 for(j=0;j<8;j++) {
  if(wd_object[order4[j]-1].i4){      /* a card turned card back forward */ 
   put_back_order(order4,7);return 1; /* if so, put all down and return  */
  }
  if(spider==1 && (order4[j]-2)%52!=last+1) {
   put_back_order(order4,7);return 1;}
  else if(spider==2 && (order4[j]-2)%26!=last+1) {
   put_back_order(order4,7);return 1;}
  last++;
 }
 /* that's it, cards 2,3,...9 are fine                           */
 /* there are still the cards 10,11,12,13                        */
 /* they should be under card 9, which is the one in order[7]    */
 /* why in order[7]? order[0] is card 2, then order[7] is card 9 */
 x1=wd_object[order4[7]-1].xcord;
 y1=wd_object[order4[7]-1].ycord;
 /* get the four cards 10,11,12,13 */
 find_stacking_order_by_coord_to_len1(x1,y1,&len,&order4[8],4);
 if(len<4) {
   /* put back all lifted 8+len, that is max=8+len-1=7+len */
   put_back_order(order4,7+len); 
  return 1;
 } 
 /* so, there were four cards under 9 */
 for(j=8;j<12;j++) {
  if(wd_object[order4[j]-1].i4){ /* if any of them is back up */
   put_back_order(order4,11);    /* put back 8+4=12 cards     */      
   return 1;
  }
  if(spider==1 && (order4[j]-2)%52!=last+1){
   put_back_order(order4,11);return 1;}
  else if(spider==2 && (order4[j]-2)%26!=last+1){
   put_back_order(order4,11);return 1;}
  last++;  
 }  
 /* it is a full suite in id,order4[0]..order4[11], remove it */
 /* all windows have been removed from stacking order         */
 if(!put) movingPicture((int)xnew,(int)ynew,1,(int)id);
 /* remove the ace, it is hidden and not in stack */
 if_b_opt_bgfromfile(id);
 free_one_wd_object(id);
 for(j=0;j<12;j++) { /* 12 cards under the ace */
  /* are in the correct stacking order in the order vector */
  /* all are hidden and they are removed from the stack    */
  i=order4[j];
  if(!(wd_object[i-1].options&WINDOW_HIDDEN) || !over_is_zero(i-1)) {
   printf("check_if_full.. error, %d is not hidden\n",i);
   getchar();
  }
  if_b_opt_bgfromfile(i);
  free_one_wd_object(i);
 }
 *king=i;    /* the last card is a king */
 savetrace(id,-1,xnew,ynew,order4,12); /* write a bound for a suite */
 return -1;  /* indicate that this suite is moved to removed suites */
}
